unit UMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ShellAPI, StdCtrls, FileCtrl, ExtCtrls, BrowsDlg, Buttons;

type
  TMain = class(TForm)
    FileList: TListView;
    IconList: TImageList;
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    BrowseDialog1: TBrowseDialog;
    procedure Button1Click(Sender: TObject);
    procedure BrowseDialog1SelectionChanged(Sender: TObject; Wnd: Integer;
      Path: string; var ShowText: string; var OKButtonState: TOKButtonState);
  private
    { Private 錾 }
    procedure SetFilesToList(CurDir: string);
  public
    { Public 錾 }
  end;

var
  Main: TMain;

implementation

{$R *.DFM}

procedure TMain.SetFilesToList(CurDir: string);
var
  SearchRec: TSearchRec;
  Temp: TListItem;
  Icon: TIcon;
  PT: Word;
  SHFileInfo: TSHFileInfo;
  tmpStyle: TViewStyle;
begin
  Screen.Cursor := crHourGlass;
  FileList.SortType := stNone;
  tmpStyle := FileList.ViewStyle;
  FileList.Items.BeginUpdate;
  FileList.ViewStyle := vsList;
  Icon := TIcon.Create;
  try
    if CurDir[Length(CurDir)] <> '\' then
      CurDir := CurDir + '\';
    IconList.Clear;
    FileList.Items.Clear;
    FindFirst(CurDir + '*.*', faAnyFile, SearchRec);
    repeat
      if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') and
           (SearchRec.Attr and FaVolumeID <= 0) then
      begin
        Temp := FileList.Items.Add;
        Temp.Caption := SearchRec.Name;
        SHGetFileInfo(PChar(CurDir + SearchRec.Name), 0, SHFileInfo,
          SizeOf(SHFileInfo), SHGFI_LARGEICON or SHGFI_ICON);
        Icon.Handle :=  SHFileInfo.hIcon;
        Temp.ImageIndex := IconList.AddIcon(Icon);
      end;
    until FindNext(SearchRec) <> 0;
  finally
    Icon.Free;
    FindClose(SearchRec);
    FileList.ViewStyle := tmpStyle;
    FileList.SortType := stText;
    FileList.Items.EndUpdate;
    Screen.Cursor := crDefault;
  end;
end;

procedure TMain.Button1Click(Sender: TObject);
begin
  if BrowseDialog1.Execute then
  begin
    Edit1.Text := BrowseDialog1.DisplayName;
    SetFilesToList(BrowseDialog1.Directory);
  end;
end;

procedure TMain.BrowseDialog1SelectionChanged(Sender: TObject;
  Wnd: Integer; Path: string; var ShowText: string;
  var OKButtonState: TOKButtonState);
begin
  ShowText := Path;
  if Pos(' ', Path) <> 0 then
  begin
    ShowText := 'No Space!';
    OKButtonState := obsDisabled;
  end;
end;

end.
